translateapp/accounts/urls.py
from django.urls import path
from . import views

app_name = "accounts"

urlpatterns = [
        path('dashboard', views.dashboard, name="dashboard"),
        path('profile/<int:user_id>', views.profile, name="profile"),
        path('register', views.register, name="register"),
        path('edit_profil/', views.edit_profil, name="edit_profil"),
]

translateapp/app/urls.py
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
        path('jobs', views.jobs_index, name="jobs"),
        path('jobs/new', views.new_job, name="new_job"),
        path('jobs/<int:job_id>', views.job_detail, name="job_detail"),
        path('jobs/<int:job_id>/bid', views.bid, name="bid"),
        path('bids/<int:bid_id>/accept', views.accept_bid, name="accept_bid"),
        path('bids/<int:bid_id>/deliver', views.deliver_translation, name="deliver_translation"),
        path('bids/<int:bid_id>', views.bid_detail, name="bid_detail"),
        path('bids/<int:bid_id>/rating', views.rate_bid, name="rate_bid"),
        path('bids/<int:bid_id>/dispute', views.raise_dispute, name="dispute"),
        path('message/<int:receiver_id>', views.send_message, name="send_message"),
        
]

translateapp/blog/urls.py
from django.urls import path, include

from . import views

app_name = "blog"

urlpatterns = [
    path('', views.blog, name="blog"),
    path('new', views.new_blog, name="new_blog"),
    path('posts/', views.posts, name='posts'),
    path('post/<int:post_id>/', views.post_detail, name='post_detail'),
    path('user_posts/<int:user_id>/', views.user_posts, name='user_posts'),
    path('edit_post/<int:blog_id>/', views.edit_post, name='edit_post'),
    path('delete_post/<int:blog_id>/', views.delete_post, name='delete_post'),
    path('delete_comment/<int:comment_id>/', views.delete_comment, name='delete_comment'),
]

translateapp/messenger/urls.py
from django.urls import path, include

from . import views

app_name = "messenger"

urlpatterns = [
    path('', views.messenger, name="messenger"),
    path('<int:user_id>', views.thread, name="thread"),
]

translateapp/translateapp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('app/', include('app.urls')),
    path('blog/', include('blog.urls')),
    path('messenger/', include('messenger.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

translateapp/accounts/models.py
from django.db import models

# Create your models here.

translateapp/app/models.py
import datetime
from time import timezone
from django.db import models
from django.conf import settings
from datetime import datetime

from django.contrib.auth.models import User
from django.db.models import Q

class Account(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100)
    balance = models.DecimalField(max_digits=8, decimal_places=2, default=0)
    translator = models.BooleanField()
    avatar_url = models.URLField(blank=True, null=True)
    profile= models.ImageField(upload_to='avatars/',blank=True,null=True)
  
    def __str__(self):
        return f"{self.id} - {self.name}"

    def rating(self):
        ratings = Rating.objects.filter(rated=self.user)
        if ratings.count() == 0:
            return "No ratings yet"
        else:
            score = [ rating.rating for rating in ratings ]
            return sum(score) / len(score)

    def raise_if_invalid_balance(self):
        if self.balance < 0:
            raise ValueError("Balance cannot be negative")

    def active_jobs(self):
        return self.user.job_set.exclude(status='completed')

    def completed_jobs(self):
        return self.user.job_set.filter(status='completed')

class Job(models.Model):
    class Status(models.TextChoices):
        AVAILABLE = 'available', "Available"
        ASSIGNED = 'assigned', "Assigned"
        IN_PROGRESS = 'in_progress', "In Progress"
        COMPLETED = 'completed', "Completed"

    class Field(models.TextChoices):
        ART = 'art', "Art"
        BUS = 'business', "Business"
        COMP = 'computers', "Computers"
        EDU = 'education', "Education"
        ENG = 'engineering', "Engineering"
        FIN = 'finance', "Finance"
        LAW = 'law', "Law"
        LIT = 'literature', "Literature"
        MED = 'medicine', "Medicine"
        SCI = 'science', "Science"
        SOC = 'social_sciences', "Social Sciences"
        TECH = 'technology', "Technology"

    class Language(models.TextChoices):
        ENG = 'en', "English"
        SPA = 'spa', "Spanish"
        FRE = 'fr', "French"
        GER = 'de', "German"
        ITA = 'it', "Italian"
        JPN = 'ja', "Japanese"
        CRO = 'hr', "Croatian"

    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title = models.CharField(max_length=256)
    description = models.CharField(max_length=512)
    created_at = models.DateTimeField(auto_now_add=True)
    deadline = models.DateTimeField(null=True)

    source_lang = models.CharField(
            max_length=3, 
            choices=Language.choices,
            default=Language.ENG,
    )
    target_lang = models.CharField(
            max_length=3,
            choices=Language.choices,
            default=Language.CRO,
    )
    field = models.CharField(
            max_length=100,
            choices=Field.choices,
            default=Field.ENG,
    )
    budget = models.DecimalField(max_digits=8, decimal_places=2)
    text = models.TextField()
    status = models.CharField(
            max_length=100, 
            choices=Status.choices,
            default=Status.AVAILABLE,
    )
    translation = models.TextField(blank=True, null=True)
    
    def active_jobs(self):
        return self.user.job_set.exclude(status='completed')

    def completed_jobs(self):
        return self.user.job_set.filter(status='completed')


    def deadline_days(self):
        dline = self.deadline
        if dline:
            now = datetime.now()
            x = dline.day - now.day
            return x
        else: 
            return None
    
    def __str__(self):
        return f"{self.user.account.name} - {self.title}"

    def accepted_bid(self):
        return self.bid_set.filter(accepted=True).first()

    def accepted_bidder(self):
        return self.accepted_bid().bidder.account

    def owner(self):
        return self.user.account

    # Helper method to check if the job is available, since checking the status
    # directly from the template is not very readable.
    def is_available(self):
        return self.status == self.Status.AVAILABLE

    def is_completed(self):
        return self.status == self.Status.COMPLETED

    def ordered_bids(self):
        return self.bid_set.order_by('-accepted')

    def bid_by_user(self, user):
        return self.bid_set.filter(bidder=user).first()

    def can_bid(self, user):
        # If user didn't bid already on the job and is not the job owner
        return self.bid_by_user(user) is None and self.user != user


    @classmethod
    def accepted_jobs_for(cls, user):
        # Svi bidovi gdje je user napravio job na koji je biddano
        accepted_bids = Bid.objects.filter(job__in=user.job_set.all(), accepted=True)
        # Svi jobovi gdje je user napravio job i bidano je na job 
        accepted_jobs = [ bid.job for bid in accepted_bids if bid.job.status != "completed" ]
        return accepted_jobs

class Bid(models.Model):
    bidder = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    price = models.DecimalField(max_digits=8, decimal_places=2)
    accepted = models.BooleanField(default=False)
    completed = models.BooleanField(default=False)
    def __str__(self):
        return f"{self.bidder.account.name} - {self.job.title} - {self.price}"
    def job_owner(self):
        return self.job.user

class Dispute(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    reason = models.TextField(blank=False, null=False)

class Message(models.Model):
    sender = models.ForeignKey(User, on_delete=models.CASCADE, related_name='sender')
    receiver = models.ForeignKey(User, on_delete=models.CASCADE, related_name='receiver')
    text = models.TextField(blank=False, null=False)
    sent_at = models.DateTimeField(auto_now_add=True)
    is_read = models.BooleanField(default=False)


   
    def __str__(self):
        return f"{self.sender.account.name} - {self.receiver.account.name} - {self.text[:20]}"
    
   

    def text_snippet(self):
        return f"{self.text[:30]}..."
    

    @classmethod
    def get_thread(cls, user1, user2):
        return cls.objects.filter(sender__in=[user1, user2], receiver__in=[user1, user2]).order_by('sent_at')
    
    @classmethod
    def get_thread_last_two(cls, user1, user2):
        return cls.objects.filter(sender__in=[user1, user2], receiver__in=[user1, user2]).order_by('-sent_at')[:2]



    @classmethod
    def get_thread_users(cls, user):
        # Using Q objects
        #https://docs.djangoproject.com/en/4.1/topics/db/queries/#complex-lookups-with-q-objects
        
        messages = Message.objects.filter(Q(sender=user) | Q(receiver=user)).order_by('-sent_at')
        ordered_users = []
        for message in messages:
            if message.sender != user and message.sender not in ordered_users:
                ordered_users.append(message.sender)
            if message.receiver != user and message.receiver not in ordered_users:
                ordered_users.append(message.receiver)

        return ordered_users

    @classmethod
    def get_threads_for(cls, my_user):
        users = cls.get_thread_users(my_user)
        threads = [ [user, cls.get_thread(my_user, user)] for user in users ]
        return threads
    
    @classmethod
    def get_threads_for_two(cls, my_user):
        users = cls.get_thread_users(my_user)
        threads = [ [user, cls.get_thread_last_two(my_user, user)] for user in users ]
        return threads
    


class Rating(models.Model):
    rater = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rater')
    rated = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rated')
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    rating = models.IntegerField()

class Blog(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title = models.CharField(max_length=256)
    text = models.TextField()
    publish_date = models.DateTimeField()
    blog_image=models.ImageField(upload_to='blog_img/',blank=True,null=True)

class Comment(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    blog = models.ForeignKey(Blog, on_delete=models.CASCADE, related_name='comments')  
    text = models.TextField()

translateapp/accounts/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from django.utils import timezone
from django.urls import reverse

from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from app.models import Account, Job, Bid, Dispute, Message, Rating
from app.forms import UserForm, AccountForm


# Create your views here.

# See the comment in forms.py for an explanation of why we use two forms
def register(request):
    if request.method == 'POST':
        # Each form is validated separately, each form takes the data from the
        # request that is relevant to it.
        user_form = UserForm(request.POST)
        account_form = AccountForm(request.POST)
        # Only if both forms are valid, we save the data to the database
        if user_form.is_valid() and account_form.is_valid():
            user = user_form.save()
            # We need to set the password separately, because the UserForm
            # doesn't have a password field, it uses two fields for the password
            # and password confirmation.
            user.set_password(user_form.cleaned_data['password1'])
            user.save()

            # We need to set the user field on the account before we can save it
            account = account_form.save(commit=False)
            account.user = user
            account.save()
            return HttpResponseRedirect(reverse('accounts:dashboard'))
        else:
            return render(request, 'accounts/register.html', {'user_form': user_form, 'account_form': account_form})
    else:
        user_form = UserForm()
        account_form = AccountForm()
        return render(request, 'accounts/register.html', {'user_form': user_form, 'account_form': account_form})

@login_required
def dashboard(request):
    user = request.user
    my_jobs = user.job_set.all()
    my_completed_jobs = user.account.completed_jobs()
    my_active_jobs = user.account.active_jobs()

    my_threads = Message.get_threads_for_two(user)
    my_bids = user.bid_set.all()
    my_won_bids = user.bid_set.filter(accepted=True)
    context = {
        'my_jobs': my_jobs,
        'my_active_jobs': my_active_jobs,
        'my_completed_jobs': my_completed_jobs,
        'my_threads': my_threads,
        'my_bids': my_bids,
        'my_won_bids': my_won_bids,
    
    
    }

    return render(request, 'accounts/dashboard.html', context)


def profile(request, user_id):
    user = get_object_or_404(User, pk=user_id)

    accepted_jobs = Job.accepted_jobs_for(user)
    completed_jobs = Job.objects.filter(user=user, status='completed')
    

    bids = user.bid_set.all()
    won = user.bid_set.filter(accepted=True)

    context = {
        'profile_user': user,
        'accepted_jobs': accepted_jobs,
        'completed_jobs': completed_jobs,
        
        'bids': bids,
        'won': won,
    }
    return render(request, 'accounts/profile.html', context)

def edit_profil(request):
    user = request.user
    account = user.account
    if request.method == 'POST':
        account_form = AccountForm(request.POST,request.FILES ,instance=account)
        if account_form.is_valid():
            account_form.save()
            return HttpResponseRedirect(reverse('accounts:profile',args=[user.id]))
    else:
        account_form = AccountForm(instance=account)
    
    context = {
        'account_form': account_form
        }
    return render(request, 'accounts/edit_profil.html', context)

translateapp/accounts/templates/accounts/dashboard.html
{% extends 'app/base.html' %}

<!--USER DASHBOARD-->

{% load static %}
<head>
  <link rel="stylesheet" href="{% static 'app/css/message_card.css' %}">
</head>

{% block content %}

<div class="container">
  <div class="row">
    <div class="col-md-8">
      <h1 class="mb-5 mt-5">Hello {{ user.account.name }}</h1>
      {% if user.account.translator %}
        <h4>Translator - Rating: {{ user.account.rating }}</h4>
      {% endif %}
      <p class="mb-3 mt-3">Token balance: <strong>{{ user.account.balance }}</strong></p>
      <pclass="mb-3 mt-3">Email: {{ user.email }}</p>

      <h2 class="mt-5 mb-4">My Active Jobs</h2>

      {% for job in my_active_jobs %}
        {% include 'includes/my_job_card.html' with job=job bids=job.ordered_bids %}
      {% empty %}
        <p>You don't have any jobs yet.</p>
      {% endfor %}

      <h2 class="mt-5 mb-4">My Completed Jobs</h2>

      {% for job in my_completed_jobs %}
        {% include 'includes/my_job_card.html' with job=job bids=job.ordered_bids %}
      {% empty %}
        <p>You don't have any jobs yet.</p>
      {% endfor %}


      {% if user.account.translator %}
      <h2 class="mt-5 mb-1">My translations dashboard</h2><hr>
          
       <h2 class="mt-5 mb-4">My bids</h2>
        {% for bid in my_bids  %}
        <div class="card my-4 shadow-sm p-3 mb-5 rounded card-body m-2 rounded bid {% if bid.accepted %} accepted {% endif %}">
          <p>
          <strong>My bid on {{ bid.job.title }} for {{ bid.price }} tokens.</strong>
          </p>
          <p>
          {{ bid.job.description }}</br>
          From {{ bid.job.get_source_lang_display }} to {{ bid.job.get_target_lang_display }}.
          </p>
          <p>Field: {{ bid.job.get_field_display }}; Status:  {{ bid.job.status   }}</p>
      
        </div>
        {% empty %}
          <p>You don't have any bids yet.</p>
        {% endfor %}

      <h2 class="mt-5 mb-4">My won bids (Jobs assigned to me)</h2>
        {% for bid in my_won_bids  %}
          {% if not bid.completed %}
            {% include 'includes/my_bid_card.html' with bid=bid %}
          {% endif %}
        {% empty %}
          <p>You don't have any won bids yet.</p>
        {% endfor %}

      <h2>My completed jobs</h2>
        {% for bid in my_won_bids  %}
          {% if bid.completed %}
          {% include 'includes/my_bid_card.html' with bid=bid %}
          {% endif %}
        {% empty %}
          <p>You don't have any completed jobs yet.</p>
        {% endfor %}


      {% endif %}
    </div>
    <div class="col-md-4">
      <h1 class="mb-5 mt-5">Messages</h1>
      <div class="rounded card p-3">
      

      
          {% for thread_user, thread in my_threads %}
              <h3 >  
                <a href="{% url 'messenger:thread' thread_user.account.id %}" class="custom-link">
                  {{  thread_user.account.name  }}   </a> 
              </h3>
              {% for message in thread %}
                  {% include 'includes/message_card.html' with message=message user=user%}
              {% endfor %}
          {% empty %}
              <p>You don't have any messages yet.</p>
          {% endfor %}
      </div>
  </div>
  
    
  </div>
  
</div>

{% endblock content %}

translateapp/accounts/templates/accounts/edit_profil.html
{% extends 'app/base.html' %}

{% block content %}


<head>
    <title>Uredi Profil</title>
</head>
<body>
    <h2>Uredi Profil</h2>
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ account_form.as_p }}
        <button type="submit">Spremi Promjene</button>
    </form>
    
</body>

{% endblock content %}

translateapp/accounts/templates/accounts/profile.html
{% extends 'app/base.html' %}

<!--USER PROFILE -->
{% load static %}
{% block content %}

<div class="container">
  <div class="row">
    <div class="col-md-12">
      <h1 class="mb-5 mt-5 ">{{ profile_user.account.name }}'s profile page</h1>
      <a href="{% url 'blog:user_posts' profile_user.id %}" class="btn custom-btn2 ms-3 mt-2 mb-5">Users Post</a>
      <a href="{% url 'messenger:thread' profile_user.account.id%}" class="btn custom-btn2 ms-3 mt-2 mb-5">Message User</a>
      {% if user == profile_user %}

        <a href="{% url 'accounts:edit_profil' %}" class="btn custom-btn2 ms-3 mt-2 mb-5">Edit Profile</a>
        <br>
      {% endif %}
      <br>
<!--
  
      {% if profile_user.account.avatar_url %}
       
          <img 
          style="width: 200 x; 
          height: 200px;"
          src="{{ profile_user.account.avatar_url }}" alt="Avatar">
      {% endif %}


      
    
     <br><br>

-->


{% if profile_user.account.profile %}
    <img src="{{ profile_user.account.profile.url }}" alt="Profile">
{% else %}
    <img src="/media/default_profile_image.jpeg" alt="Default">
{% endif %}
    
      {% if user.account.translator %}
        <h4>Translator - Rating: {{ profile_user.account.rating }}</h4>
      {% endif %}
      <h5 class="mb-3 mt-3">Email: {{ profile_user.email }}</h5>
    </div>
  </div>
  <div class="row">
    <div class="col-md-12">
      <h2 class="mt-5 mb-4 text-center">User's accepted jobs</h2>
      {% for job in accepted_jobs  %}
        {% include 'includes/job_card.html' with job=job %}
      {% empty %}
        <p class="text-center">No accepted jobs</p>
      {% endfor %}

    </div>
    <div class="col-md-12">
      <h2 class="mt-5 mb-4 text-center">User's completed jobs</h2>
      {% for job in completed_jobs  %}
        {% include 'includes/job_card.html' with job=job %}
      {% empty %}
        <p class="text-center">No completed jobs</p>
      {% endfor %}

    </div>
    {% if user.account.translator %}
      <div class="col-md-12">
        <h2 class="mt-5 mb-1">Translator's stats</h2><hr>
        <h2 class="mt-5 mb-4 text-center">User's bids</h2>
        {% for bid in bids  %}
          <div class="card my-4 shadow-sm p-3 mb-5">
            <div class="card-body m-2">
              <h4>Bid on {{ bid.job.title }} for {{ bid.price }} tokens</h4>
                
                {% if bid.accepted %}
                  <p class="won-job">Won the job!</p>
                {% else %}
                  <p class="lost-job">Someone else was cheaper :(</p>
                {% endif %}
            </div>
          </div>
        {% empty %}
          <p class="text-center">No bids on any jobs</p>
        {% endfor %}

        <h2 class="mt-5 mb-4 text-center">Won jobs - currently working on:</h2>
        {% for bid in won  %}
          <div class="card my-4 shadow-sm p-3 mb-5">
            <div class="card-body m-2">
              <h4>{{ bid.job.title }} for {{ bid.price }} tokens</h4>
                <p>Translating from 
                  {{ bid.job.get_source_lang_display }} to 
                  {{ bid.job.get_target_lang_display }} a text 
                  in the field of {{ bid.job.get_field_display }}.
                </p>
                <p>Job posted by <a href="{% url "accounts:profile" bid.job.user.id %}">{{ bid.job.user.account.name }}</a></p>
            </div>
          </div>
        {% empty %}
          <p class="text-center">Didn't win any jobs!</p>
        {% endfor %}

      </div>
    {% endif %}
  </div>
  
</div>

{% endblock content %}

translateapp/accounts/templates/accounts/register.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <div class="ms-auto">
    <h1 class="mb-5 mt-5">Register an account with us!</h1>
  <form method="post">
    {% csrf_token %}

    {% for hidden in user_form.hidden_fields %}
      {{ hidden }}
    {% endfor %}
    {% for hidden in account_form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          <h2>Enter you user details</h2>
          {% for field in user_form.visible_fields %}
            <div class="form-group margin--bottom">
              <label for="{{ field.id_for_label }}">{{ field.label }}</label>
              {{ field|add_class:'form-control' }}
              {% for error in field.errors %}
                <span class="help-block">{{ error }}</span>
              {% endfor %}
            </div>
          {% endfor %}

          <h2>Enter you account details</h2>

          <div class="form-group margin--bottom">
            <label for="{{ account_form.name.id_for_label }}">{{ account_form.name.label }}</label>
            {{ account_form.name|add_class:'form-control' }}
            {% for error in account_from.name.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>

          <div class="form-switch margin--bottom">
            {{ account_form.translator|add_class:'form-check-input' }}
            <label class="form-check-label" for="{{ account_form.translator.id_for_label }}">{{ account_form.translator.label }}</label>
            {% for error in account_from.translator.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>

          <div class="form-group">
            <button type="submit" class="btn custom-btn px-4 py-2 mb-4">
              <span class="glyphicon glyphicon-ok"></span> Save
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default mb-4">Cancel</a>
          </div>
        </div>
      </div>
    </div>
  </form>
  </div>
{% endblock %}